/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package GUI;

import DB.Connection;
import DB.Teacher;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.LinkedList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JTable;
import javax.swing.table.AbstractTableModel;

/**
 *
 * @author swinkx
 */
public class TeacherTable {
    private JTable table;
    
    public TeacherTable(){
        MyTableModel myTAbleModel = new MyTableModel();
        table = new JTable(myTAbleModel);
        
        //lekérjük az adatbázis kapcsoaltot
        Connection connection = Connection.getInstance();
        
        //Select
        ResultSet rs = connection.executeQuery("select TEACHER_ID,FIRST_NAME,LAST_NAME from P.TEACHER");//select * fromP.teacher
        try {
            while(rs.next()){ //minden sorra
                int id = rs.getInt(1);//rs.getInt("TEACHER_ID");
                
                String fname = rs.getString("FIRST_NAME");
                String lname = rs.getString("LAST_NAME");
                
                //hozzáadjuk a modelhez az új sort
                myTAbleModel.addTeacher(new Teacher(id, fname, lname));
            }
        } catch (SQLException ex) {
            Logger.getLogger(TeacherTable.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
     
    public JTable getTable(){
        return table;
    }
     
    /**
     * Tábla model a teacher táblához
     */
    private class MyTableModel extends AbstractTableModel{
        private String[] columns = {"ID", "First Name", "Second Name"};//oszlopok nevei
        
        private List<Teacher> data = new LinkedList<Teacher>();
        
        public void addTeacher(Teacher t){
            data.add(t);
        }
        
        //kötelező felülírni
        @Override
        public int getRowCount() {
            return data.size();
        }

        //kötelező felülírni
        @Override
        public int getColumnCount() {
            return columns.length;
        }

        //kötelező felülírni
        @Override
        public Object getValueAt(int arg0, int arg1) {
            Teacher t = data.get(arg0);
            switch(arg1){
                case 0:
                    return t.getTeacherID();
                case 1:
                    return t.getFirstName();
                case 2:
                    return t.getLastName();
                default:
                    return null;
            }
        }
        
        //A következőket már nem muszáj felülírni, de ajánlott, hiszen:
        
        //Ez szükséges, hogy legyen az oszlopainknak neve
        @Override
        public String getColumnName(int col) {
            return columns[col];
        }
        
        //A megfelelő megjelenítéshez szüksgéges(checkbox/integer)
        @Override
        public Class getColumnClass(int c) {
            return getValueAt(0, c).getClass();
        }
        
        //alapból nem lehet változtatni a táblázat értékeit.
        @Override
        public boolean isCellEditable(int row, int col) {   
            if (col < 2) {
                return false;
            } else {
                return true;
            }
        }
        
        //Ha ezt nem írjuk felül, akkor nem menti a változtatásokat
        @Override
        public void setValueAt(Object value, int row, int col) {
            Teacher t = data.get(row);
            switch(col){
                case 0:
                    t.setTeacherID((Integer)value);
                    break;
                case 1:
                    t.setFirstName((String)value);
                    break;
                case 2:
                    t.setLastName((String)value);
                    break;
                default:
                    ;
            }
            
            fireTableCellUpdated(row,col);//Ez értesíti az összes listenert( a TableModelListener is), hogy változás történt
            
            //fireTableDataChanged();//itt jelezhetjük, hogy a (teljes) táblázat változott, ezért azt újra kell rajzolni!
        }
    }
}
