package swingschooljdbc.gui;

import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.table.AbstractTableModel;
import swingschooljdbc.logic.DataSource;
import swingschooljdbc.logic.Student;

class StudentsTableModel extends AbstractTableModel {

    @Override
    public int getRowCount() {
        try {
            return DataSource.getInstance().getStudentsCount();
        } catch (SQLException ex) {
            SwingSchoolFrame.showError(ex.getMessage());
            return 0;
        }
    }

    @Override
    public int getColumnCount() {
        return 3;
    }

    @Override
    public Object getValueAt(int rowIndex, int columnIndex) {
        Student student;
        try {
            student = DataSource.getInstance().getStudent(rowIndex);
        } catch (SQLException ex) {
            SwingSchoolFrame.showError(ex.getMessage());
            return "?";
        }
        switch(columnIndex){
            case 0: return student.getFirstName();
            case 1: return student.getLastName();
            case 2: return student.getGroupp().getName();
            default: return null;
        }
    }
}
