package swingschooljdbc.logic;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

public class DataSource {

    private String url, //connection string
            username, password;

    private DataSource() {
        url = "jdbc:derby://localhost:1527/School";
        username = "root";
        password = "root";
    }

    public Connection getConnection() throws SQLException {
        return DriverManager.getConnection(url, username, password);
    }

    public static DataSource getInstance() {
        return DataSourceHolder.INSTANCE;
    }

    public int getStudentsCount() throws SQLException {
        int studentsCount;
        try (
                Connection connection = getConnection();
                Statement statement = connection.createStatement();
                ResultSet resultSet = statement.executeQuery("SELECT COUNT(*) AS CNT FROM STUDENT");) {
            resultSet.next();
            studentsCount = resultSet.getInt("CNT");
        }
        return studentsCount;
    }

    public Student getStudent(int rowIndex) throws SQLException {
        Student student = new Student();
        int groupId;
        try (
                Connection connection = getConnection();
                Statement statement = connection.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_READ_ONLY);
                ResultSet resultSet = statement.executeQuery("SELECT * FROM STUDENT");) {
            resultSet.absolute(rowIndex + 1);
            student.setStudentId(resultSet.getInt(1));
            student.setFirstName(resultSet.getString(2));
            student.setLastName(resultSet.getString(3));
            groupId = resultSet.getInt(4);
        }
        Groupp group = getGroupById(groupId);
        student.setGroupp(group);
        return student;
    }

    private Groupp getGroupById(int groupId) throws SQLException {
        Groupp group = new Groupp();
        try (
                Connection connection = getConnection();
                Statement statement = connection.createStatement();
                ResultSet resultSet = statement.executeQuery("SELECT * FROM \"GROUP\" WHERE GROUP_ID = " + groupId);) {
            resultSet.next();
            group.setGroupId(resultSet.getInt(1));
            group.setName(resultSet.getString(2));
        }
        return group;
    }

    private static class DataSourceHolder {

        private static final DataSource INSTANCE = new DataSource();
    }
}
